// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "BankSystem.h"

#include "MainFrm.h"

#include "Dialoger.h"			// indsat af Bjrk Busch
#include "TestPrintDialog.h"	// indsat af Bjrk Busch

#include "WindowsDoc.h"			// indsat af Bjrk Busch
#include "WindowsView.h"		// indsat af Bjrk Busch

#include  <odbcinst.h>	// indsat af Bjrk  - for opstning af ODBC


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(IDC_Odbcbank, OnOdbcbank)
	ON_COMMAND(IDC_ValgPrint, OnValgPrint)
	ON_COMMAND(IDC_DanTestPrint, OnDanTestPrint)
	ON_COMMAND(IDC_ValgKundeDialog, OnValgKundeDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnOdbcbank() 
{
	// indsat af Bjrk Busch

    if (!SQLConfigDataSource(// Parent window handle (Hvis NULL ingen dialogbox)
			NULL,
			// Opret ny datakilde
			ODBC_ADD_DSN,
			// ODBC Driver beskrivelse (Skal vre installeret)
			(LPSTR) "Microsoft Access Driver (*.mdb)",
			// Attribut streng (Hver delstreng NULL termineret)
			// OBS: IKKE KOMMASEPARERET!!!!!!
			// Datakilde navn
			(LPSTR) "DSN=BANKDB\0"
			// Beskrivelse
			"Description=Bank Database\0"
			// Database type
			"FileType=MS Access\0"
			// Database directory
			"DefaultDir=C:\\C++\0"
			// Database navn
			"DBQ=C:\\C++\\BANK.MDB\0\0")
			// Flgende attributter kan eventuelt ogs indg
			// "UID=UserId\0"
			// "PWD=Password\0"
			)
	{
		AfxMessageBox("Der kan ikke opsttes ODBC adgang til databasen", MB_OK | MB_ICONSTOP);
    }
	
}

void CMainFrame::OnValgPrint() 
{
	// indsat af Bjrk Busch

	CWindowsView* pView = (CWindowsView*)GetActiveView();
	CWindowsDoc* pDoc = pView->GetDocument(); 
	pDoc->SelectReport();
	pDoc->UpdateAllViews(NULL);
}

void CMainFrame::OnDanTestPrint() 
{
	CdlgTestPrintDialog TestPrintDialog;	// opret en instans af en kundedialog
	TestPrintDialog.DoModal();				// aktiver dialogen
}

void CMainFrame::OnValgKundeDialog() 
{
	CdlgKundeDialog KundeDialog;	// opret en instans af en kundedialog
	KundeDialog.DoModal();			// aktiver dialogen
}

