// WindowsDoc.cpp : implementation of the CWindowsDoc class
//

#include "stdafx.h"
#include "BankSystem.h"

#include "WindowsDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWindowsDoc

IMPLEMENT_DYNCREATE(CWindowsDoc, CDocument)

BEGIN_MESSAGE_MAP(CWindowsDoc, CDocument)
	//{{AFX_MSG_MAP(CWindowsDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWindowsDoc construction/destruction

CWindowsDoc::CWindowsDoc()
{
	// TODO: add one-time construction code here

	pMyReport	= NULL;
	ReportView	= TRUE;		// ingen view af rapporter - kun print
}

CWindowsDoc::~CWindowsDoc()
{
}

void CWindowsDoc::AssignReport(void)
{	
	if (pMyReport == NULL)
		pMyReport = ReportHandler.GetFirstReport();
}


void CWindowsDoc::SelectReport(void)
{	
	CxReport* pReport;
	CString Text;

	pMyReport = NULL;
	
	pReport = ReportHandler.GetFirstReport();

	while ((pReport != NULL) && (pMyReport == NULL))
	{
		Text.Format("Vil du vlge printet  (%ld) \"%s\"",
					pReport->GetReportID(), pReport->GetReportName());
		int Svar = AfxMessageBox(Text, MB_YESNOCANCEL|MB_ICONQUESTION);
		if (Svar == IDYES)
			pMyReport = pReport;
		else if (Svar == IDNO)
			pReport = ReportHandler.GetNextReport();
		else if (Svar == IDCANCEL)
			pReport = NULL;
	}

	pMyReport = pReport;
}

void CWindowsDoc::DeleteReport()
{
	CString Text;
	if (pMyReport != NULL)
	{
		Text.Format("Vil du SLETTE printet (%ld) \"%s\"",
				pMyReport->GetReportID(), pMyReport->GetReportName());
		int Svar = AfxMessageBox(Text, MB_YESNO|MB_ICONSTOP|MB_DEFBUTTON2);
		if (Svar == IDYES)
			ReportHandler.RemoveReport(pMyReport);
	}
	pMyReport = NULL;
	UpdateAllViews(NULL);
}

long CWindowsDoc::GetMaxLinesPerPage(void)
{
	if (pMyReport != NULL)
		return (pMyReport->GetMaxLinesPerPage());
	else
		return (66);
}
void CWindowsDoc::DanRapport(CxReportMetrics* pMetrics, ReportTypeType ReportType)
{
	//-------------------------------------------------------------
	// her opbygges et dokument

	nDocType = 1;
	csaDocLines.RemoveAll();		// slet evt. tidligere data
	
	if (pMyReport != NULL)
	{
		pMyReport->SetLinesPerPage(pMetrics->m_nLinesPerPage);

		if (ReportType == PrintReportType) 
			pMyReport->BeginOfPrintReport();
		else
			pMyReport->BeginOfViewReport();

		while (!pMyReport->EndOfReport())
		{
			csaDocLines.Add(pMyReport->GetLine());
		}
	}
	//-------------------------------------------------------------
}



BOOL CWindowsDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	//-------------------------------------------------------------
	// her opbygges et dokument
//	DanDocument();
	//-------------------------------------------------------------

	// (SDI documents will reuse this document)

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CWindowsDoc serialization

void CWindowsDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CWindowsDoc diagnostics

#ifdef _DEBUG
void CWindowsDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CWindowsDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWindowsDoc commands
