// WindowsView.cpp : implementation of the CWindowsView class
//

#include "stdafx.h"
#include "BankSystem.h"

#include "WindowsDoc.h"
#include "WindowsView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWindowsView

IMPLEMENT_DYNCREATE(CWindowsView, CScrollView)    // ndret fra CView

BEGIN_MESSAGE_MAP(CWindowsView, CScrollView)		// ndret fra CView
	//{{AFX_MSG_MAP(CWindowsView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWindowsView construction/destruction

CWindowsView::CWindowsView()
{
	// TODO: add construction code here

}

CWindowsView::~CWindowsView()
{
}


BOOL CWindowsView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}
/////////////////////////////////////////////////////////////////////////////
// CWindowsView message handlers

void CWindowsView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// TODO: Add your specialized code here and/or call the base class

	//-------------------------------------------------------------
	GetDocument()->AssignReport();
	CClientDC aDC(this);
    Metrics.ComputeReportMetrics(&aDC, this, GetDocument()->GetMaxLinesPerPage()); 

	GetDocument()->DanRapport(&Metrics, ViewReportType);

    CSize DocSize(Metrics.m_nLineWidth,
				 (Metrics.m_nLineHeight * 2) +   // tillg for headersize
                 (Metrics.m_nLineHeight * GetDocument()->GetDocLines()));

    SetScrollSizes(MM_TEXT, DocSize, Metrics.m_PageSize, Metrics.m_LineSize);
	Invalidate();
	//-------------------------------------------------------------

}

/////////////////////////////////////////////////////////////////////////////
// CWindowsView drawing

void CWindowsView::OnDraw(CDC* pDC)
{
	CWindowsDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here

	//-------------------------------------------------------------
	if (pDoc->nDocType == 1) // Hvis dokument skal vises
	{
		Metrics.ComputeReportMetrics(pDC, this, GetDocument()->GetMaxLinesPerPage());

		// Frste line sendt til View bruges automatisk som header
		// p alle sider ved print
		// Vi efterlader her Headeren tom da vi selv styrer hele
		// siden fra linie 0
		int HeaderSize = (Metrics.m_nLineHeight * 4)/3;

		for (long nLine = 0; nLine < pDoc->GetDocLines(); nLine++)
		{
			// Her dannes en linie til VIEW
			pDC->TextOut((Metrics.m_nMaxCharWidth * 2),
						 HeaderSize +	
						(Metrics.m_nLineHeight * nLine),
						pDoc->csaDocLines[nLine]);
		}
	}
	//-------------------------------------------------------------

}

BOOL CWindowsView::OnScroll(UINT nScrollCode, UINT nPos, BOOL bDoScroll) 
{
	// TODO: Add your specialized code here and/or call the base class
//-------------------------------------------------------------
	Invalidate();
//-------------------------------------------------------------

	return CScrollView::OnScroll(nScrollCode, nPos, bDoScroll);
}

/////////////////////////////////////////////////////////////////////////////
// CWindowsView printing

BOOL CWindowsView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CWindowsView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)  //
{
	// TODO: add extra initialization before printing

	//-------------------------------------------------------------
	// Beregn antal sider i udprintning

	GetDocument()->AssignReport();
    Metrics.ComputeReportMetrics(pDC, this, GetDocument()->GetMaxLinesPerPage());

	GetDocument()->DanRapport(&Metrics, PrintReportType);
    
	int nTotalLines = GetDocument()->GetDocLines();
    int nTotalPages = nTotalLines / Metrics.m_nLinesPerPage;
    if (nTotalLines % Metrics.m_nLinesPerPage)
            ++nTotalPages;
    pInfo->SetMaxPage(nTotalPages);

    // Start med side 1
    pInfo->m_nCurPage = 1;
	//-------------------------------------------------------------

}

void CWindowsView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
//-------------------------------------------------------------
	Invalidate();
	CWindowsDoc* pDoc = GetDocument();
	pDoc->DeleteReport();
	pDoc->UpdateAllViews(NULL);
//-------------------------------------------------------------
}

void CWindowsView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
	// TODO: Add your specialized code here and/or call the base class

	//-------------------------------------------------------------
	// Denne rutine kaldes for hver side som  udskrives
	
	CWindowsDoc* pDoc = GetDocument();

	ASSERT_VALID(pDoc);

	if (pDoc->nDocType == 1)
	{
		// Venstre margen 10 mm ekstra
		pInfo->m_rectDraw.left += 100;

		// Top margen 10 mm ekstra
		//pInfo->m_rectDraw.top += 100;		// Hvis denne bruges, skal der ogs justeres i CxMetrics

	    Metrics.ComputeReportMetrics(pDC, this, GetDocument()->GetMaxLinesPerPage());

		// Beregn frste linie p hver side
		int nFirstLine = (pInfo->m_nCurPage - 1) * Metrics.m_nLinesPerPage;
		int nLastLine  = nFirstLine + Metrics.m_nLinesPerPage;

		int nLine = 0;		// Styrer linie-position p side
		for (long i = nFirstLine; i < nLastLine; i++)
		{
			if (i < pDoc->GetDocLines())         // Print kun doc data
			{
				// Her udskrives en linie fra dokumentet
				pDC->TextOut(pInfo->m_rectDraw.left,
							(-(pInfo->m_rectDraw.top +
							(Metrics.m_nLineHeight * nLine))),
							pDoc->csaDocLines[i]);
				++nLine;
			}
		}
	}
	//-------------------------------------------------------------

	CScrollView::OnPrint(pDC, pInfo);
}

/////////////////////////////////////////////////////////////////////////////
// CWindowsView diagnostics

#ifdef _DEBUG
void CWindowsView::AssertValid() const
{
	CView::AssertValid();
}

void CWindowsView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CWindowsDoc* CWindowsView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWindowsDoc)));
	return (CWindowsDoc*)m_pDocument;
}
#endif //_DEBUG

